

if { [catch {

  source /etc/config/addons/VPN/config.tcl

 
  proc saveToFile { filename content} {
    catch {
      set fd [open $filename w]
      puts -nonewline $fd $content
      close $fd
    }
  }
  
 
 
  proc __args_init { } {
    global __args env
  
  
    while { "" != [set line [gets stdin]] } {
      if { [regexp {([^:]+):(.*)} $line dummy name value] } then {
        set __args($name) $value
      }
    }
  
  
    set __args(Content) [read stdin]
  
 
    if { [info exists env(QUERY_STRING)] } then {
      set __args(Query) $env(QUERY_STRING)
    }
  }


  proc __args_get { name } {
    global __args
  
    if { [info exists __args($name)] } {
      return $__args($name)
    } else {
      return ""
    }
  }


proc jsstring { value } {
  return [string map {
    "\\" "\\"
    "\"" "\\\""
    "\'" "\\\'"
    "\t" "\\t"
    "\r" "\\r"
    "\n" "\\n"
    
  } $value]
}


proc loadFromFile { filename } {
  set content ""
  catch  {
    set fd [open $filename r]
    set content [read $fd]
    close $fd
  }
  return $content
}

proc putAccount {} {
  global ACCOUNT_FILE
  
  array set account {}
  set account(Domain) {}
  set account(Token) {}
  set account(Port) {}
  set account(User) {}
  set account(Password) {}
 
  
  catch { array set account [loadFromFile $ACCOUNT_FILE] }
  
  puts "  \"Account\":"
  puts "  \{"
  puts "    \"Domain\": \"[jsstring $account(Domain)]\","
  puts "    \"Token\": \"[jsstring $account(Token)]\","
  puts "    \"Port\": \"[jsstring $account(Port)]\","
  puts "    \"User\": \"[jsstring $account(User)]\","
  puts "    \"Password\": \"[jsstring $account(Password)]\""
  #puts "    \"starttls\": $account(Domain)"
  puts "  \}"
 

  
}


proc putValid {} {
  global VPN_DATA_FILE account
  
  array set account {}
  set account(Domain) {}
  set account(Token) {}
  set account(Port) {}
  set account(User) {}
  set account(Password) {}
 
  
  catch { array set account [loadFromFile $VPN_DATA_FILE] }
  
  puts "  \"ValidTo\":"
  puts "  \{"
  puts "    \"Server\": \"[jsstring $account(server)]\","
  puts "    \"Port\": \"[jsstring $account(port)]\","
  puts "    \"Sub\": \"[jsstring $account(Sub)]\","
  puts "    \"ValidTo\": \"[jsstring $account(Valid)]\""
  puts "  \}"
 

  
}





 
  
  
 
  proc __VPNData { } {
    global ACCOUNT_FILE CONFIG_FILE CONFIG_FILE_A VPN_DATA_FILE
    
    array set subscriber {}
    set subscriber(Domain)   [__args_get Domain]
    set subscriber(Token)     [__args_get Token]
    set subscriber(User) [__args_get User]
    set subscriber(Password) [__args_get Password]
    set subscriber(Port) [__args_get Port]
    set subscriber(Port1) [__args_get Port]
    set subscriber(Port1) [expr $subscriber(Port1)+1]
    
    exec sh /usr/local/etc/config/addons/VPN/getinfo.sh $subscriber(Token) &
    
    saveToFile $ACCOUNT_FILE [array get subscriber]
    
    array set dat {}
    set dat(server) {}
    
    catch { array set dat [loadFromFile $VPN_DATA_FILE] }
    
    
    
    set fd [open $CONFIG_FILE w]
    

    #puts $fd "# VPN Konfigurationsdatei"
    #puts $fd "# -------------------------"
    #puts $fd "# Diese Datei wurde automatisch generiert."
    puts $fd "auth_token: '$subscriber(Token)'"
    puts $fd "server_addr: '$dat(server):4443'"
    puts $fd "inspect_addr: disabled"
    puts $fd "tunnels:"
    puts $fd "  rega:"
    puts $fd "   subdomain: '$subscriber(Domain)'"
    puts $fd "   auth: '$subscriber(User):$subscriber(Password)'"
    puts $fd "   proto:"
    puts $fd "     https: 80"
    puts $fd "  web:"
    puts $fd "   subdomain: '$subscriber(Domain)'"
    puts $fd "   auth: '$subscriber(User):$subscriber(Password)'"
    puts $fd "   proto:"
    puts $fd "     http: 80"
    puts $fd "  con:"
    puts $fd "   subdomain: '$subscriber(Domain)'"
    puts $fd "   remote_port: $subscriber(Port)"
    puts $fd "   proto:"
    puts $fd "     tcp: 2110"
    puts $fd "  ssh:"
    puts $fd "   subdomain: '$subscriber(Domain)'"
    puts $fd "   remote_port: $subscriber(Port1)"
    puts $fd "   proto:"
    puts $fd "     tcp: 22"

    close $fd
    
    
    
    set fd [open $CONFIG_FILE_A w]

    #puts $fd "# VPN Konfigurationsdatei"
    #puts $fd "# -------------------------"
    #puts $fd "# Diese Datei wurde automatisch generiert."
    puts $fd "auth_token: '$subscriber(Token)'"
    puts $fd "server_addr: '$dat(server):5443'"
    puts $fd "inspect_addr: disabled"
    puts $fd "tunnels:"
    puts $fd "  rega:"
    puts $fd "   subdomain: '$subscriber(Domain)'"
    puts $fd "   auth: '$subscriber(User):$subscriber(Password)'"
    puts $fd "   proto:"
    puts $fd "     https: 8181"
    puts $fd "  web:"
    puts $fd "   subdomain: '$subscriber(Domain)'"
    puts $fd "   auth: '$subscriber(User):$subscriber(Password)'"
    puts $fd "   proto:"
    puts $fd "     http: 8181"


    close $fd
    
    
    
    
    
    
    	
   # exec sh /usr/local/etc/config/addons/VPN/getinfo.sh $subscriber(Token)
    
    
  }
  
  
 
  
  ##############################################################################
  # Einsprungpunkt                                                             #
  ##############################################################################
  
  __args_init

  switch -exact -- [__args_get Query] {
  
    vpndata    { __VPNData 
    			
    			puts "Content-Type: text/plain"
  				puts ""
  				puts -nonewline "OK"
    
    
    }
    
    getvalid 	{ puts "Content-Type: text/javascript; charset=utf-8"
					puts ""
					
					puts "\{"
    				putValid
    				puts "\}"
    				
    				
    						}
    						
    getdata 	{ puts "Content-Type: text/javascript; charset=utf-8"
					puts ""
					
					puts "\{"
    				putAccount
    				puts "\}"
    				
    				
    						}
    						
    						
    
  
    default    { error "Unknown Command [__args_get Query]" }
  }
  
  

} errorMessage] } then {
  puts "Content-Type: text/plain"
  puts ""
  puts "ERROR $errorMessage"
}


